Logo AND Algorithmique Numérique Distribuée

Public GIT Repository
make ugly regexp a bit more robust to corner cases
[simgrid.git] / src / smpi / smpiff.in
index feb4563..3e94eb9 100644 (file)
-#! /bin/sh
-prefix="@exec_prefix@"
-
-ARGS="-DMAIN__=user_main -Diargc_=smpi_process_argc -Dgetarg_=smpi_process_getarg"
-LINKARGS="-L@F2C_LIBRARY_PATH@ -lf2c -lm"
-# $1: prefix, $2: suffix
-mymktemp () {
-    tmp=$(mktemp --suffix="$2" "$1_XXXXXXXXXX" 2> /dev/null)
-    if [ -z "$tmp" ]; then
-        # mktemp failed (unsupported --suffix ?), try unsafe mode
-        tmp=$(mktemp -u "$1_XXXXXXXXXX" 2> /dev/null)
-        if [ -z "$tmp" ]; then
-            # mktemp failed again (doesn't exist ?), try very unsafe mode
-            tmp="$1_$$x$RANDOM"
-        fi
-        tmp="${tmp}$2"
-        # create temp file, and exit if it existed before
-        sh -C -c "true > \"${tmp}\"" || exit 1
+#!/usr/bin/env sh
+
+# Copyright (c) 2012-2018. The SimGrid Team. All rights reserved.
+
+# This program is free software; you can redistribute it and/or modify it
+# under the terms of the license (GNU LGPL) which comes with this package.
+
+SIMGRID_VERSION="@SIMGRID_VERSION_STRING@"
+SIMGRID_GITHASH="@SIMGRID_GITHASH@"
+
+REAL_FORTRAN_COMPILER=@SMPI_Fortran_COMPILER@
+
+INCLUDEARGS="@includeflag@"
+CMAKE_LINKARGS="-L@libdir@"
+
+@SMPITOOLS_SH@
+
+list_set FFLAGS @SMPI_Fortran_FLAGS@
+list_set LINKARGS "-lsimgrid" @SMPI_Fortran_LIBS@ "-lm"
+if [ "x${SMPI_PRETEND_CC}" = "x" ]; then
+   list_add LINKARGS "-shared"
+else
+   echo "Warning: smpiff pretends to be a regular compiler (SMPI_PRETEND_CC is set). Produced binaries will not be usable in SimGrid."
+fi
+list_set TMPFILES
+main_name=main
+
+cleanup () {
+    eval $(list_get TMPFILES)
+    rm -f "$@"
+}
+trap 'cleanup' EXIT
+
+filter_and_compile_f77() {
+    list_add TMPFILES "${TMPFILE}"
+    #replace "program main_name by subroutine user_main (and the end clause as well)"
+    if [ $TRACE_CALL_LOCATION -gt 0 ]; then
+      echo "#include \"@includedir@/smpi/smpi_extended_traces_fortran.h\"" > ${TMPFILE}
+      echo "#line 1 \"${ARG}\"" >> ${TMPFILE}
+    fi
+    sed 's/^[[:space:]]\{6\}[[:space:]]*\([eE][nN][dD] \)\{0,1\}[pP][rR][oO][gG][rR][aA][mM][^a-zA-Z0-9]*\([a-zA-Z0-9_]*\)/      \1subroutine user_main /g' "${ARG}" >> "${TMPFILE}"
+    SRCFILE="${TMPFILE}"
+    list_add CMDLINE "${SRCFILE}"
+}
+filter_and_compile_f90() {
+    list_add TMPFILES "${TMPFILE}"
+    #replace "program main_name by subroutine user_main (and the end clause as well)"
+    if [ $TRACE_CALL_LOCATION -gt 0 ]; then
+      echo "#include \"@includedir@/smpi/smpi_extended_traces_fortran.h\"" > ${TMPFILE}
+      echo "#line 1 \"${ARG}\"" >> ${TMPFILE}
     fi
-    echo "${tmp}"
+    sed 's/^\([[:space:]]*\)\([eE][nN][dD] \)\{0,1\}[pP][rR][oO][gG][rR][aA][mM][^a-zA-Z0-9]*\([a-zA-Z0-9_]*\)/\1\2subroutine user_main /g' "${ARG}" >> "${TMPFILE}"
+    SRCFILE="${TMPFILE}"
+    list_add CMDLINE "${SRCFILE}"
 }
+TRACE_CALL_LOCATION=0
+NEEDS_OUTPUT=1
 
-SRCFILES=""
-while [ -n "$1" ]; do
-  ARG="$1"
-  shift
-  case "${ARG}" in
-    *.f)
-      SRCFILE="$(readlink -f ${ARG} 2>/dev/null)"
-       if [ -z "$SRCFILE" ] ; then
-         SRCFILE="$ARG"
-       fi
-       SRCFILES="${SRCFILES} ${SRCFILE}"
-       ;;
-    *)
-      if [ "${ARG}" = "-c" ]; then
-          LINKARGS=""
-      fi
-      ARGS="${ARGS} ${ARG}"
-      ;;
-  esac
+list_set CMDLINE "${REAL_FORTRAN_COMPILER}"
+list_add_not_empty CMDLINE "${FFLAGS}"
+while [ $# -gt 0 ]; do
+    ARG="$1"
+    shift
+    case "${ARG}" in
+        -c)
+            CMAKE_LINKARGS=""
+            LINKARGS=""
+            list_add CMDLINE "-c"
+            ;;
+        *.f)
+            FILENAME=`basename ${ARG}`
+            TMPFILE=$(mymktemp "${ARG}" ".f")
+            ORIGFILE="${FILENAME%.f}"
+            filter_and_compile_f77
+            ;;
+        *.F)$
+            FILENAME=`basename ${ARG}`
+            TMPFILE=$(mymktemp "${ARG}" ".F")
+            ORIGFILE="${FILENAME%.F}"
+            filter_and_compile_f77
+            ;;
+        *.f90)
+            FILENAME=`basename ${ARG}`
+            TMPFILE=$(mymktemp "${ARG}" ".f90")
+            ORIGFILE="${FILENAME%.f90}"
+            filter_and_compile_f90
+            ;;
+        *.F90)$
+            FILENAME=`basename ${ARG}`
+            TMPFILE=$(mymktemp "${ARG}" ".F90")
+            ORIGFILE="${FILENAME%.F90}"
+            filter_and_compile_f90
+            ;;
+        '-version' | '--version')
+            printf '%b\n' "$SIMGRID_VERSION"
+            exit 0
+            ;;
+        "-git-version" | "--git-version")
+            printf '%b\n' "$SIMGRID_GITHASH"
+            exit 0
+            ;;
+        '-compiler-version' | '--compiler-version')
+            ${REAL_FORTRAN_COMPILER} --version
+            ;;
+        '-trace-call-location')
+            TRACE_CALL_LOCATION=1
+            # This should be list_add FFLAGS but it's not possible
+            # anymore: FFLAGS was already moved into CMDLINE above.
+            list_add_not_empty CMDLINE "-ffixed-line-length-none" "-cpp"
+            ;;
+        -o)
+            list_add CMDLINE "-o$1"
+            NEEDS_OUTPUT=0
+            shift
+            ;;
+        *)
+            list_add CMDLINE "${ARG}"
+            ;;
+    esac
 done
-ARGS="${ARGS} ${LINKARGS}"
-
-if [ -n "${SRCFILES}" ]
-then
-   for SRCFILE in ${SRCFILES}
-   do
-      TMPFILE=$(mymktemp "${SRCFILE}" ".f")
-      cp ${SRCFILE} ${TMPFILE}
-      CFILE="${TMPFILE%.f}.c"
-      #echo "$prefix/bin/smpif2c ${TMPFILE} && $prefix/bin/smpicc ${ARGS} ${CFILE} && rm ${CFILE} && rm ${TMPFILE}"
-      $prefix/bin/smpif2c ${TMPFILE} && $prefix/bin/smpicc ${ARGS} ${CFILE} && rm ${CFILE} && rm ${TMPFILE} || exit $?
-      # When the file is compiled with "-c" and no output file is specified with
-      # "-o", rename the output.  FIXME: do it properly.
-      if [ -f ${CFILE%.c}.o ]; then
-          mv ${CFILE%.c}.o ${SRCFILE%.f}.o
-      fi
-   done
-else
-   #echo "$prefix/bin/smpicc ${ARGS}"
-   $prefix/bin/smpicc ${ARGS}
+
+if [ $NEEDS_OUTPUT -ne 0 ]; then
+   list_add CMDLINE "-o${ORIGFILE}.o"
 fi
+
+list_add_not_empty CMDLINE ${INCLUDEARGS}
+list_add_not_empty CMDLINE ${CMAKE_LINKARGS}
+list_add_not_empty CMDLINE "${LINKARGS}"
+
+eval $(list_get CMDLINE)
+"$@"